﻿Public Class App
    Shared _me As App = Nothing

    Public Shared ReadOnly Property Instance() As App
        Get
            If App._me Is Nothing Then
                App._me = New App
            End If
            Instance = App._me
        End Get
    End Property

    Private Sub New()
        ' UNDONE:
        With Me
            Dim tablet = WindowsApplication1.Tablet.Instance("tablet2")
            Dim invoker = New DrawFreehandLine(tablet)
            Dim files = System.IO.Directory.GetFiles(System.IO.Path.Combine(System.Windows.Forms.Application.StartupPath, "Plugin"), "*.dll", IO.SearchOption.AllDirectories).GetEnumerator()
            Do While files.MoveNext()
                Debug.Print("DLL:" & DirectCast(files.Current, String))
                Dim commands = tablet.Commands(invoker.GetType())
                Dim stroke = tablet.StrokeModifier(invoker.GetType())
                Dim a = Reflection.Assembly.LoadFrom(DirectCast(files.Current, String))
                Dim types = a.GetTypes().GetEnumerator()
                Do While types.MoveNext()
                    Dim t = DirectCast(types.Current(), Type)
                    Debug.Print("Found:" & t.FullName)
                    If t.IsSubclassOf(Type.GetType("WindowsApplication1.Plugin.Command,WindowsApplication1.Plugin", True, True)) Then
                        If t.FullName = "WindowsApplication1.Plugin.Commands.StandardBrushCommand" Then
                            Debug.Print("Loaded (Command):" & t.FullName)
                            commands.Add(a.CreateInstance(t.FullName))
                        Else
                            Debug.Print("Not Loaded (Command):" & t.FullName)
                        End If
                    ElseIf t.IsSubclassOf(Type.GetType("WindowsApplication1.Plugin.StrokeModifier,WindowsApplication1.Plugin", True, True)) Then
                        Debug.Print("Loaded (StrokeModifier):" & t.FullName)
                        stroke = a.CreateInstance(t.FullName)
                    End If
                Loop
                tablet.Commands(invoker.GetType()) = commands
                tablet.StrokeModifier(invoker.GetType()) = stroke
            Loop
        End With

        'With Me
        '    Dim tablet = WindowsApplication1.Tablet.Instance("tablet2")
        '    Dim invoker = New DrawFreehandLine(tablet)
        '    Dim commands = tablet.Commands(invoker.GetType())
        '    commands.Add(New WindowsApplication1.Plugin.Commands.ベタブラシで描画)
        '    tablet.Commands(invoker.GetType()) = Commands
        '    tablet.StrokeModifier(invoker.GetType()) = New WindowsApplication1.Plugin.Strokes.NullStroke
        'End With

        With Me
            Dim tablet = WindowsApplication1.Tablet.Instance("tablet1")
            Dim invoker = New DrawFreehandLine(tablet)
            Dim commands = tablet.Commands(invoker.GetType())
            commands.Add(New WindowsApplication1.Plugin.Commands.NullBrushCommand)
            tablet.Commands(invoker.GetType()) = commands
            tablet.StrokeModifier(invoker.GetType()) = New Plugin.Strokes.NullStroke
        End With
    End Sub
End Class
